Index: examples/fruits_rt2_typed/README
===================================================================
--- examples/fruits_rt2_typed/README	(revision 5aaeca3ffd52e2c878b0b8fe3028ce89f896d1b5)
+++ examples/fruits_rt2_typed/README	(revision 36b100a555bbe4b19efa9a040e53943ddde6946f)
@@ -3,7 +3,7 @@
 rm -rf *.der *.pem
 
-# mary.what2eat<-?-orange  good
-# bob.what2eat<-?-orange  bad
-# ralphs.fruitprice(1.50)<-?-apple good
+# mary.what2eat<-?-navel orange  good
+# bob.what2eat<-?-navel orange  bad
+# ralphs.fruitprice(1.50)<-?-apple   good
 
 creddy --generate --cn Mary
@@ -39,17 +39,17 @@
         --out Ralphs_fruitprice__apple_attr.der
 
-# [keyid:ralphs].oset:fruitprice([float:2.50]) <- [string:'blueberry']
+# [keyid:ralphs].oset:fruitprice([float:2.50]) <- [string:'black rasberry']
 creddy --attribute \
         --issuer Ralphs_ID.pem --key Ralphs_private.pem \
         --oset "fruitprice([float:2.50])" \
-        --subject-obj "[string:'blueberry']" \
-        --out Ralphs_fruitprice__blueberry_attr.der
+        --subject-obj "[string:'black rasberry']" \
+        --out Ralphs_fruitprice__black_rasberry_attr.der
 
-# [keyid:ralphs].oset:fruitprice([float:0.50]) <- [string:'orange']
+# [keyid:ralphs].oset:fruitprice([float:0.50]) <- [string:'navel orange']
 creddy --attribute \
         --issuer Ralphs_ID.pem --key Ralphs_private.pem \
         --oset "fruitprice([float:0.50])" \
-        --subject-obj "[string:'orange']" \
-        --out Ralphs_fruitprice__orange_attr.der
+        --subject-obj "[string:'navel orange']" \
+        --out Ralphs_fruitprice__navel_orange_attr.der
 
 #####################################################################
@@ -65,9 +65,9 @@
 # [keyid:ralphs].oset:fruitprice([float:1.50]) <- [string:'apple']
 #
-# ralphs.fruitprice(2.50)<-blueberry
-# [keyid:ralphs].oset:fruitprice([float:2.50]) <- [string:'blueberry']
+# ralphs.fruitprice(2.50)<-black rasberry
+# [keyid:ralphs].oset:fruitprice([float:2.50]) <- [string:'black rasberry']
 #
-# ralphs.fruitprice(0.50)<-orange
-# [keyid:ralphs].oset:fruitprice([float:0.50]) <- [string:'orange']
+# ralphs.fruitprice(0.50)<-navel orange
+# [keyid:ralphs].oset:fruitprice([float:0.50]) <- [string:'navel orange']
 # 
 
Index: examples/fruits_rt2_typed/creds_dump
===================================================================
--- examples/fruits_rt2_typed/creds_dump	(revision 5aaeca3ffd52e2c878b0b8fe3028ce89f896d1b5)
+++ examples/fruits_rt2_typed/creds_dump	(revision 36b100a555bbe4b19efa9a040e53943ddde6946f)
@@ -1,5 +1,5 @@
  pRalphs.fruitprice(1.50) <- 'apple'
- pRalphs.fruitprice(2.50) <- 'blueberry'
- pRalphs.fruitprice(0.50) <- 'orange'
+ pRalphs.fruitprice(2.50) <- 'black rasberry'
+ pRalphs.fruitprice(0.50) <- 'navel orange'
  pBob.what2eat <- pRalphs.fruitprice(P:[1.00..5.00])
  pMary.what2eat <- pRalphs.fruitprice(P:[..2.00])
Index: examples/fruits_rt2_typed/rr
===================================================================
--- examples/fruits_rt2_typed/rr	(revision 5aaeca3ffd52e2c878b0b8fe3028ce89f896d1b5)
+++ examples/fruits_rt2_typed/rr	(revision 36b100a555bbe4b19efa9a040e53943ddde6946f)
@@ -19,15 +19,23 @@
 $eloc/abac_prover_yap  --keystore $keyloc --dump creds_dump
 
-# [keyid:mary].oset:what2eat <-?- [string:'orange'] (yes)
-echo "===good============ mary.what2eat <- orange yap "
-$eloc/abac_prover_yap  --keystore $keyloc --oset "$mary_what2eat" --object "[string:'orange']"
+# [keyid:mary].oset:what2eat <-?- [string:'navel orange'] (yes)
+echo " "
+echo "===good============ mary.what2eat <- navel orange yap "
+$eloc/abac_prover_yap  --keystore $keyloc --oset "$mary_what2eat" --object "[string:'navel orange']"
 
-# [keyid:bob].oset:what2eat <-?- [string:'orange'] (no)
-echo "===bad============ bob.what2eat <- orange yap "
-$eloc/abac_prover_yap  --keystore $keyloc --oset "$bob_what2eat" --object "[string:'orange']"
+# [keyid:bob].oset:what2eat <-?- [string:'navel orange'] (no)
+echo " "
+echo "===bad============ bob.what2eat <- navel orange yap "
+$eloc/abac_prover_yap  --keystore $keyloc --oset "$bob_what2eat" --object "[string:'navel orange']"
 
 # [keyid:$ralphs].oset:fruitprice([float:1.50]) <-?- [string:'apple'] (yes)
+echo " "
 echo "===good============ ralphs.fruitprice(1.50) <- apple yap "
 $eloc/abac_prover_yap  --keystore $keyloc --oset "$ralphs_apple" --object "[string:'apple']"
 
+# [keyid:$ralphs].oset:fruitprice([float:1.50]) <-?- [string:'green apple'] (no)
+echo " "
+echo "===bad============ ralphs.fruitprice(1.50) <- green apple yap "
+$eloc/abac_prover_yap  --keystore $keyloc --oset "$ralphs_apple" --object "[string:'green apple']"
 
+